!  SUBROUTINE Unterprogramm
!  Uebergeben von Arrays
!
   PROGRAM EinAus
      IMPLICIT NONE
      INTEGER :: I
      INTEGER, PARAMETER :: IMAX=200
      CHARACTER*256, PARAMETER :: FNAME='werte.dat'
      DOUBLE PRECISION :: X(IMAX)

      I=IMAX

      CALL EINLESEN(X,I,FNAME)
      WRITE(*,*)I," Werte"
      CALL AUSGABE(X,I,1)

   END

!-----------------------------------------------------------
   SUBROUTINE EINLESEN(A,N,FNAME)
      IMPLICIT NONE
      DOUBLE PRECISION :: A
      INTEGER :: I,N
      CHARACTER*256 :: FNAME
!     A ... feld
!     N ... Groesse feld
!     FNAME ... Dateiname
!     Das Feld A enthaelt nach dem Aufruf die eingelesenen Werte

      DIMENSION A(N)
      OPEN(UNIT=1, FILE=FNAME, ERR=200, STATUS='OLD')

      DO I=1,N
         READ (1,*,END=300,ERR=210)A(I)
      END DO
300   N=I-1
      CLOSE(1)
      RETURN

200   WRITE(*,*)'Fehler beim Oeffnen:',FNAME
      STOP
210   WRITE(*,*)'Lesefehler:',FNAME
      STOP
      RETURN
   END
!-----------------------------------------------------------
   SUBROUTINE AUSGABE(A,N,KIO)
      IMPLICIT NONE
      DOUBLE PRECISION :: A
      INTEGER :: I,N,KIO
      CHARACTER*256 :: FNAME
!     A ... feld
!     N ... Groesse feld
!     KIO ... Steuert Ausgabe
      DIMENSION A(N)

      DO I=1,N
         IF (KIO.EQ.0) WRITE(*,*) A(I)
         IF (KIO.EQ.1) WRITE(*,*) I,A(I)
      END DO
      RETURN
   END
!-----------------------------------------------------------

